# pcre2build man page

Return to the PCRE2 index page.

This page is part of the PCRE2 HTML documentation. It was generated automatically from the original man page. If there is any nonsense in it, please consult the man page, in case the conversion went wrong.

- BUILDING PCRE2
- PCRE2 BUILD-TIME OPTIONS
- BUILDING 8-BIT, 16-BIT AND 32-BIT LIBRARIES
- BUILDING SHARED AND STATIC LIBRARIES
- UNICODE AND UTF SUPPORT
- JUST-IN-TIME COMPILER SUPPORT
- NEWLINE RECOGNITION
- WHAT \R MATCHES
- HANDLING VERY LARGE PATTERNS
- AVOIDING EXCESSIVE STACK USAGE
- LIMITING PCRE2 RESOURCE USAGE
- CREATING CHARACTER TABLES AT BUILD TIME
- USING EBCDIC CODE
- PCRE2GREP OPTIONS FOR COMPRESSED FILE SUPPORT
- PCRE2GREP BUFFER SIZE
- PCRE2TEST OPTION FOR LIBREADLINE SUPPORT
- INCLUDING DEBUGGING CODE
- DEBUGGING WITH VALGRIND SUPPORT
- CODE COVERAGE REPORTING
- SEE ALSO
- AUTHOR
- REVISION

BUILDING PCRE2

PCRE2 is distributed with a configure script that can be used to build the library in Unix-like environments using the applications known as Autotools. Also in the distribution are files to support building using CMake instead of configure. The text file README contains general information about building with Autotools (some of which is repeated below), and also has some comments about building on various operating systems. There is a lot more information about building PCRE2 without using Autotools (including information about using CMake and building "by hand") in the text file called NON-AUTOTOOLS-BUILD. You should consult this file as well as the README file if you are building in a non-Unix-like environment.

PCRE2 BUILD-TIME OPTIONS

The rest of this document describes the optional features of PCRE2 that can be selected when the library is compiled. It assumes use of the configure script, where the optional features are selected or deselected by providing options to configure before running the make command. However, the same options can be selected in both Unix-like and non-Unix-like environments if you are using CMake instead of configure to build PCRE2.

If you are not using Autotools or CMake, option selection can be done by editing the config.h file, or by passing parameter settings to the compiler, as described in NON-AUTOTOOLS-BUILD.

The complete list of options for configure (which includes the standard ones such as the selection of the installation directory) can be obtained by running

      ./configure --help

The following sections include descriptions of options whose names begin with --enable or --disable. These settings specify changes to the defaults for the configure command. Because of the way that configure works, --enable and --disable always come in pairs, so the complementary option always exists as well, but as it specifies the default, it is not described.
BUILDING 8-BIT, 16-BIT AND 32-BIT LIBRARIES

By default, a library called libpcre2-8 is built, containing functions that take string arguments contained in vectors of bytes, interpreted either as single-byte characters, or UTF-8 strings. You can also build two other libraries, called libpcre2-16 and libpcre2-32, which process strings that are contained in vectors of 16-bit and 32-bit code units, respectively. These can be interpreted either as single-unit characters or UTF-16/UTF-32 strings. To build these additional libraries, add one or both of the following to the configure command:

      --enable-pcre2-16
      --enable-pcre2-32

If you do not want the 8-bit library, add

      --disable-pcre2-8

as well. At least one of the three libraries must be built. Note that the POSIX wrapper is for the 8-bit library only, and that pcre2grep is an 8-bit program. Neither of these are built if you select only the 16-bit or 32-bit libraries.
BUILDING SHARED AND STATIC LIBRARIES

The Autotools PCRE2 building process uses libtool to build both shared and static libraries by default. You can suppress an unwanted library by adding one of

      --disable-shared
      --disable-static

to the configure command.
UNICODE AND UTF SUPPORT

By default, PCRE2 is built with support for Unicode and UTF character strings. To build it without Unicode support, add

      --disable-unicode

to the configure command. This setting applies to all three libraries. It is not possible to build one library with Unicode support, and another without, in the same configuration.

Of itself, Unicode support does not make PCRE2 treat strings as UTF-8, UTF-16 or UTF-32. To do that, applications that use the library can set the PCRE2_UTF option when they call pcre2_compile() to compile a pattern. Alternatively, patterns may be started with (*UTF) unless the application has locked this out by setting PCRE2_NEVER_UTF.

UTF support allows the libraries to process character code points up to 0x10ffff in the strings that they handle. It also provides support for accessing the Unicode properties of such characters, using pattern escapes such as \P, \p, and \X. Only the general category properties such as Lu and Nd are supported. Details are given in the pcre2pattern documentation.

Pattern escapes such as \d and \w do not by default make use of Unicode properties. The application can request that they do by setting the PCRE2_UCP option. Unless the application has set PCRE2_NEVER_UCP, a pattern may also request this by starting with (*UCP).

The \C escape sequence, which matches a single code unit, even in a UTF mode, can cause unpredictable behaviour because it may leave the current matching point in the middle of a multi-code-unit character. It can be locked out by setting the PCRE2_NEVER_BACKSLASH_C option.

JUST-IN-TIME COMPILER SUPPORT

Just-in-time compiler support is included in the build by specifying

      --enable-jit

This support is available only for certain hardware architectures. If this option is set for an unsupported architecture, a building error occurs. See the pcre2jit documentation for a discussion of JIT usage. When JIT support is enabled, pcre2grep automatically makes use of it, unless you add

      --disable-pcre2grep-jit

to the "configure" command.
NEWLINE RECOGNITION

By default, PCRE2 interprets the linefeed (LF) character as indicating the end of a line. This is the normal newline character on Unix-like systems. You can compile PCRE2 to use carriage return (CR) instead, by adding

      --enable-newline-is-cr

to the configure command. There is also an --enable-newline-is-lf option, which explicitly specifies linefeed as the newline character.

Alternatively, you can specify that line endings are to be indicated by the two-character sequence CRLF (CR immediately followed by LF). If you want this, add

      --enable-newline-is-crlf

to the configure command. There is a fourth option, specified by

      --enable-newline-is-anycrlf

which causes PCRE2 to recognize any of the three sequences CR, LF, or CRLF as indicating a line ending. Finally, a fifth option, specified by

      --enable-newline-is-any

causes PCRE2 to recognize any Unicode newline sequence. The Unicode newline sequences are the three just mentioned, plus the single characters VT (vertical tab, U+000B), FF (form feed, U+000C), NEL (next line, U+0085), LS (line separator, U+2028), and PS (paragraph separator, U+2029).

Whatever default line ending convention is selected when PCRE2 is built can be overridden by applications that use the library. At build time it is conventional to use the standard for your operating system.

WHAT \R MATCHES

By default, the sequence \R in a pattern matches any Unicode newline sequence, independently of what has been selected as the line ending sequence. If you specify

      --enable-bsr-anycrlf

the default is changed so that \R matches only CR, LF, or CRLF. Whatever is selected when PCRE2 is built can be overridden by applications that use the called.
HANDLING VERY LARGE PATTERNS

Within a compiled pattern, offset values are used to point from one part to another (for example, from an opening parenthesis to an alternation metacharacter). By default, in the 8-bit and 16-bit libraries, two-byte values are used for these offsets, leading to a maximum size for a compiled pattern of around 64K code units. This is sufficient to handle all but the most gigantic patterns. Nevertheless, some people do want to process truly enormous patterns, so it is possible to compile PCRE2 to use three-byte or four-byte offsets by adding a setting such as

      --with-link-size=3

to the configure command. The value given must be 2, 3, or 4. For the 16-bit library, a value of 3 is rounded up to 4. In these libraries, using longer offsets slows down the operation of PCRE2 because it has to load additional data when handling them. For the 32-bit library the value is always 4 and cannot be overridden; the value of --with-link-size is ignored.
AVOIDING EXCESSIVE STACK USAGE

When matching with the pcre2_match() function, PCRE2 implements backtracking by making recursive calls to an internal function called match(). In environments where the size of the stack is limited, this can severely limit PCRE2's operation. (The Unix environment does not usually suffer from this problem, but it may sometimes be necessary to increase the maximum stack size. There is a discussion in the pcre2stack documentation.) An alternative approach to recursion that uses memory from the heap to remember data, instead of using recursive function calls, has been implemented to work round the problem of limited stack size. If you want to build a version of PCRE2 that works this way, add

      --disable-stack-for-recursion

to the configure command. By default, the system functions malloc() and free() are called to manage the heap memory that is required, but custom memory management functions can be called instead. PCRE2 runs noticeably more slowly when built in this way. This option affects only the pcre2_match() function; it is not relevant for pcre2_dfa_match().
LIMITING PCRE2 RESOURCE USAGE

Internally, PCRE2 has a function called match(), which it calls repeatedly (sometimes recursively) when matching a pattern with the pcre2_match() function. By controlling the maximum number of times this function may be called during a single matching operation, a limit can be placed on the resources used by a single call to pcre2_match(). The limit can be changed at run time, as described in the pcre2api documentation. The default is 10 million, but this can be changed by adding a setting such as

      --with-match-limit=500000

to the configure command. This setting has no effect on the pcre2_dfa_match() matching function.

In some environments it is desirable to limit the depth of recursive calls of match() more strictly than the total number of calls, in order to restrict the maximum amount of stack (or heap, if --disable-stack-for-recursion is specified) that is used. A second limit controls this; it defaults to the value that is set for --with-match-limit, which imposes no additional constraints. However, you can set a lower limit by adding, for example,

      --with-match-limit-recursion=10000

to the configure command. This value can also be overridden at run time.
CREATING CHARACTER TABLES AT BUILD TIME

PCRE2 uses fixed tables for processing characters whose code points are less than 256. By default, PCRE2 is built with a set of tables that are distributed in the file src/pcre2_chartables.c.dist. These tables are for ASCII codes only. If you add

      --enable-rebuild-chartables

to the configure command, the distributed tables are no longer used. Instead, a program called dftables is compiled and run. This outputs the source for new set of tables, created in the default locale of your C run-time system. (This method of replacing the tables does not work if you are cross compiling, because dftables is run on the local host. If you need to create alternative tables when cross compiling, you will have to do so "by hand".)
USING EBCDIC CODE

PCRE2 assumes by default that it will run in an environment where the character code is ASCII or Unicode, which is a superset of ASCII. This is the case for most computer operating systems. PCRE2 can, however, be compiled to run in an 8-bit EBCDIC environment by adding

      --enable-ebcdic --disable-unicode

to the configure command. This setting implies --enable-rebuild-chartables. You should only use it if you know that you are in an EBCDIC environment (for example, an IBM mainframe operating system).

It is not possible to support both EBCDIC and UTF-8 codes in the same version of the library. Consequently, --enable-unicode and --enable-ebcdic are mutually exclusive.

The EBCDIC character that corresponds to an ASCII LF is assumed to have the value 0x15 by default. However, in some EBCDIC environments, 0x25 is used. In such an environment you should use

      --enable-ebcdic-nl25

as well as, or instead of, --enable-ebcdic. The EBCDIC character for CR has the same value as in ASCII, namely, 0x0d. Whichever of 0x15 and 0x25 is not chosen as LF is made to correspond to the Unicode NEL character (which, in Unicode, is 0x85).

The options that select newline behaviour, such as --enable-newline-is-cr, and equivalent run-time options, refer to these character values in an EBCDIC environment.

PCRE2GREP OPTIONS FOR COMPRESSED FILE SUPPORT

By default, pcre2grep reads all files as plain text. You can build it so that it recognizes files whose names end in .gz or .bz2, and reads them with libz or libbz2, respectively, by adding one or both of

      --enable-pcre2grep-libz
      --enable-pcre2grep-libbz2

to the configure command. These options naturally require that the relevant libraries are installed on your system. Configuration will fail if they are not.
PCRE2GREP BUFFER SIZE

pcre2grep uses an internal buffer to hold a "window" on the file it is scanning, in order to be able to output "before" and "after" lines when it finds a match. The size of the buffer is controlled by a parameter whose default value is 20K. The buffer itself is three times this size, but because of the way it is used for holding "before" lines, the longest line that is guaranteed to be processable is the parameter size. You can change the default parameter value by adding, for example,

      --with-pcre2grep-bufsize=50K

to the configure command. The caller of \fPpcre2grep\fP can override this value by using --buffer-size on the command line..
PCRE2TEST OPTION FOR LIBREADLINE SUPPORT

If you add one of

      --enable-pcre2test-libreadline
      --enable-pcre2test-libedit

to the configure command, pcre2test is linked with the libreadline orlibedit library, respectively, and when its input is from a terminal, it reads it using the readline() function. This provides line-editing and history facilities. Note that libreadline is GPL-licensed, so if you distribute a binary of pcre2test linked in this way, there may be licensing issues. These can be avoided by linking instead with libedit, which has a BSD licence.

Setting --enable-pcre2test-libreadline causes the -lreadline option to be added to the pcre2test build. In many operating environments with a sytem-installed readline library this is sufficient. However, in some environments (e.g. if an unmodified distribution version of readline is in use), some extra configuration may be necessary. The INSTALL file for libreadline says this:

      "Readline uses the termcap functions, but does not link with
      the termcap or curses library itself, allowing applications
      which link with readline the to choose an appropriate library."

If your environment has not been set up so that an appropriate library is automatically included, you may need to add something like

      LIBS="-ncurses"

immediately before the configure command.
INCLUDING DEBUGGING CODE

If you add

      --enable-debug

to the configure command, additional debugging code is included in the build. This feature is intended for use by the PCRE2 maintainers.
DEBUGGING WITH VALGRIND SUPPORT

If you add

      --enable-valgrind

to the configure command, PCRE2 will use valgrind annotations to mark certain memory regions as unaddressable. This allows it to detect invalid memory accesses, and is mostly useful for debugging PCRE2 itself.
CODE COVERAGE REPORTING

If your C compiler is gcc, you can build a version of PCRE2 that can generate a code coverage report for its test suite. To enable this, you must install lcov version 1.6 or above. Then specify

      --enable-coverage

to the configure command and build PCRE2 in the usual way.

Note that using ccache (a caching C compiler) is incompatible with code coverage reporting. If you have configured ccache to run automatically on your system, you must set the environment variable

      CCACHE_DISABLE=1

before running make to build PCRE2, so that ccache is not used.

When --enable-coverage is used, the following addition targets are added to the Makefile:

      make coverage

This creates a fresh coverage report for the PCRE2 test suite. It is equivalent to running "make coverage-reset", "make coverage-baseline", "make check", and then "make coverage-report".

      make coverage-reset

This zeroes the coverage counters, but does nothing else.

      make coverage-baseline

This captures baseline coverage information.

      make coverage-report

This creates the coverage report.

      make coverage-clean-report

This removes the generated coverage report without cleaning the coverage data itself.

      make coverage-clean-data

This removes the captured coverage data without removing the coverage files created at compile time (*.gcno).

      make coverage-clean

This cleans all coverage data including the generated coverage report. For more information about code coverage, see the gcov and lcov documentation.
SEE ALSO

pcre2api(3), pcre2-config(3).

AUTHOR

Philip Hazel
University Computing Service
Cambridge, England.

REVISION

Last updated: 24 April 2015
Copyright © 1997-2015 University of Cambridge.

Return to the PCRE2 index page.